<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use \Util\Exception;

class FidelidadeUDS {

	const IDORIGEMVENDA_TABLE = 'MES_PKR';
    const IDORIGEMVENDA_BILL = 'CMD_PKC';
    const IDORIGEMVENDA_REGISTER = 'BAL_MOB';

	protected $FidelidadeUDSService;
	protected $util;
	protected $entityManager;
	
	public function __construct(
		\Service\FidelidadeUDS $FidelidadeUDSService,
		\Util\Util $util,
		\Doctrine\ORM\EntityManager $entityManager
		){
		$this->FidelidadeUDSService   = $FidelidadeUDSService;
		$this->util                   = $util;
		$this->entityManager          = $entityManager;
	}

	public function SalvaFidelidadeUDS(Request\Filter $request, Response $response) {
		try {
			$params = $request->getFilterCriteria()->getConditions();
			$chave = $params[0]['value'];
			$session = $this->util->getSessionVars($chave);
			$NRVENDAREST  	= $params[1]['value'];
			$NRCOMANDA  	= $params[2]['value'];
			$NRCPFFIDUDS    = $params[3]['value'];
			$VRDESCCASHUDS  = $params[4]['value'];
			$result = $this->FidelidadeUDSService->SalvaFidelidadeUDS($session['CDFILIAL'],$session['CDLOJA'],$session['CDCAIXA'],$NRVENDAREST,$NRCOMANDA,$NRCPFFIDUDS,$VRDESCCASHUDS);
		} catch (\Exception $e) {
			Exception::logException($e);
			$result = array('error' => true,'message' => $e->getMessage());
		}
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('SalvaFidelidadeUDS', $result));
	}

	public function ConsultaFidelidadeUDS(Request\Filter $request, Response $response) {
		try {
			$params = $request->getFilterCriteria()->getConditions();
			$modo  			= $params[0]['value'];
			$CDFILIAL  		= $params[1]['value'];
			$CDCLIENTE  	= $params[2]['value'];
			$CDCONSUMIDOR  	= $params[3]['value'];
			$TOTALVENDA  	= $params[4]['value'];
			$NRCPFFIDUDS  	= $params[5]['value'];
			$ORIGEMMESA		= null;

			if ($modo == 'M'){
				$ORIGEMMESA = $IDORIGEMVENDA_TABLE;
			} else if ($modo == 'B') {
				$ORIGEMMESA = $IDORIGEMVENDA_REGISTER;
			} else if ($modo == 'C') {
				$ORIGEMMESA = $IDORIGEMVENDA_BILL;
			}

			$params = array($CDCLIENTE, $CDCONSUMIDOR);
			$CDTIPOCONS = $this->entityManager->getConnection()->fetchAssoc("TIPO_CONSUMIDOR", $params);

			$result = $this->FidelidadeUDSService->ConsultaFidelidadeUDS($CDFILIAL, $CDCLIENTE, $TOTALVENDA, $CDTIPOCONS, $ORIGEMMESA, $NRCPFFIDUDS);
		} catch (\Exception $e) {
			Exception::logException($e);
			$result = array('error' => true,'message' => $e->getMessage());
		}
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ConsultaFidelidadeUDS', $result));
	}
}